﻿from math import *
import numpy as np

#Méthode dichotomique:

def f(x):
    return x**2+6*x+1

def g(x):
    return 10*(-8)*x**2-0.8*x+10**-8

def dicho(f,a,b,epsilon):
    while abs(a-b)>epsilon:
        m=(b+a)/2
        if f(a)*f(m)>=0:
            a=m
        else:
            b=m
    return (a+b)/2

eps=10**(-12)

#print(dicho(f,-10,10,eps))
print(dicho(g,8*10**6,8*10**8,eps))

def dichostop(f,a,b,epsilon):
    i=0
    while i<((log(abs(b-a))/log(10)-log(epsilon)/log(10))/(log(2)/log(10)))//2 + 1:
        i+=1
        m=(b+a)/2
        if f(a)*f(m)>=0:
            a=m
        else:
            b=m
    return (a+b)/2

print(dichostop(g,-2,2,eps))
#print(dichostop(f,-10,0,eps))

#Méthode de Newton:

def Newton1(f,df,x0,n):
    if n==0:
        return x0
    else:
        return Newton1(f,df,x0,n-1)-f(Newton1(f,df,x0,n-1))/df(Newton1(f,df,x0,n-1))

"""def Newton2(f,df,x0,n,epsilon):
    while abs(f(Newton1(f,df,x0,n))/df(Newton1(f,df,x0,n)))>=epsilon:"""


