# Equations de la chaleur


import matplotlib.pyplot as plt

#CI et CL :

""" T(n.h,0)=T1 pour n.h<L1
    T(n.h,0)=T2 pour n.h<L1+L2

    T(0,i.k)=T1 pour 0<= i.k <= D
    T(L1+L2,ik)=T2 pour 0<= i.k <= D """

#1
Longueur=1
duree=500
k=0.01
h=0.01
alpha=0.0001
T1=0
T2=1

#2 DÃ©termination de Nx et Nt en fonction de l'initialisation
Nx=int(Longueur/h)
Nt=int(duree/k)


#3
T=[[1 if j>=Nx//2 else 0 for j in range (Nx)]for i in range (Nt)]

#4 initialisation de T suivant les conditions initiales (au temps t=0)
T[0]=[]


#5 Calcul des valeurs de T^t_x (suivant la convention du schÃ©ma) : Ã©valuation du schÃ©ma explicite





#6 dÃ©finition d'une distribution pour les abscissses
dist=[i*h for i in range(Nx)]

#CrÃ©ation des figures
#7
plt.figure(1)
plt.plot(dist,T[int(Nt/4)],'k--',linewidth=2)
plt.plot(dist,T[int(Nt/2)],'k-.',linewidth=2)
plt.plot(dist,T[int(3*Nt/4)],'k:',linewidth=2)
plt.plot(dist,T[-1],'k',linewidth=2)
plt.plot(dist,T[0],'k')

plt.xlabel('longueur (m)',fontsize=14)
plt.ylabel('tempÃ©rature (Â°C)',fontsize=14)
plt.legend(('t=125 s','t=250s','t=375s','t=500s'))

#8
plt.figure(2)
plt.imshow(T)
plt.colorbar()
plt.axis('tight')
plt.ylabel('durÃ©e (seconde)',fontsize=14)
plt.xlabel('longueur (m)',fontsize=14)

#Affichage des figures
plt.show()
