﻿# Créé par Alexandre, le 12/09/2017 en Python 3.2
#Info Mines 2017

#Q1
"""Si la voiture est présente booleen TRUE sinon FALSE"""

#Q2

A=[True,False,True,True,False,False,False,False,False,False,True]

#Q3

def occupe(L,i):
    return L[i]

#Q4
"""Il existe 2**n files de longeur n différentes 2 car 2 choix possibles et ce n fois"""

#Q5

def egal(L1,L2):
    return L1==L2

#Q6
"""Complexité en o(n) où n=len(L1) #TEST"""

#Q7
"""Cette fonction retourne un booleen True si le test est verifié, False sinon"""

"""Fonction primaire :"""

def avancer(L,b):
    return [b] + L[:-1]

#Q8
"""Cette instruction renvoie [True,False,True,False,True,True,False,False,False,False,False]"""

#Q9

def avancer_fin(L,m):
    return L[:m] + avancer(L[m:],False)

#Q10

def avancer_debut(L,b,m):
    return avancer(L[:m+1],b) + L[m+1:]

#Q11

def avancer_debut_bloquer(L,b,m):
    new=L[:]    #copie de travail
    for i in range(m-2,-1,-1):   #On doit vérifier que les cases m-2 à 0 sont inoccupées dans le sens inverse pas de -1, les autres navancent pas
        if occupe(new,i+1)==False: #On commence par la derniere case à check sur laquelle on peut avancer cad m-1
            new[i+1]=new[i]  #Si inoccupée alors la case k peut avancer
            new[i]=False
    new[0]=b or new[0]   #affecte True si b=True et que la case est libre/ affiche True si la case est occupé est b=False
    return new

#Q12

def avancer_files(L1,b1,L2,b2):
    m=len(L1)//2
    R2=avancer_fin(L2,m)  #On avance la file L2 jusqu'à m
    R1=avancer(L1,b1)  #L1 est la file prioritaire
    if occupe(R1,m):
        R2=avancer_debut_bloquer(R2,b2,m) #cf Q11
    else:
        R2=avancer_debut(R2,b2,m) #La case m est disponible donc L2 peut avancer
    return [R1,R2]

#Q13
"""La fonction renvoie [[False,False,True,False,True],[False,True,False,True,False]]"""

#Q14
"""La liste L1 est pleine et à chaque déplacement on ajoute une voiture sur la premiere case de L1, ainsi la case du milieu(#croisement) est toujours occcupé et donc L2, une file occupé en m-1, ne peut pas avancer bloqué pour toujours"""

#Q15
"""Il suffit de 9 étapes pour passer de la configuration (a) à (b) : on fait avancer la file L1 en ajoutant aucune voiture 4 fois puis une derniere fois en commencant à faire bouger la file L2 sans ajouter de voiture puis encore 4 fois le deplacement de L2 seule car L1 immobile"""

#Q16
"""Non c'est impossible en une étape à partir de a"""


#Programme

def recherche(but, init):
    if egal(but,init):
        return 0
    n=0
    espace = [init]
    stop = False
    while not stop:
        ancien = espace
        espace = espace + successeurs(espace)
        espace.sort() #permet de trier espace par ordre croissant
        espace = elim_double(espace)
        stop = egal(ancien,espace) #fonction définie à la question 5
        n+=1
        if but in espace:
            return n
    return False

def successeurs(L):
    res=[]
    for x in L:
        L1 = x[0]
        L2 = x[1]
        res.append(avancer_files(L1,False,L2,False))
        res.append(avancer_files(L1,False,L2,True))
        res.append(avancer_files(L1,True,L2,False))
        res.append(avancer_files(L1,True,L2,True))
    return res

#Q17

def elim_double(L):
    new=[L[0]]
    for i in range(1,len(L)):
        if L[i] != L[i-1]:
            new.append(L[i])
    return new

#Q18
"""[1,2,3,5]"""

#Q19
"""Non car elle compare que si les éléments consécutifs sont différents ex: [1,2,5,1]"""

#Q20
"""type(return(recherche))= Booleen
   type(but)= Liste de Listes de Booleen
   type(espace)= Liste de Listes de Listes de Booleen
   type(return(successeurs))= Liste de Listes de Listes de Booleen"""

#Q21
"""complexité en o(n) pour in1 et o(ln(n)) pour in2 avec une dichotomie opérée, d'où in2 meilleur"""

#Q22

def versEntier(L):
    som=0
    for b in L:
        som*=2
        if b:
            som+=1
    return som

#Q23
"""taille doit valoir au minimum le nombre de chiffres de n en bases 2 #binaire"""

def versFile(n,taille):
    res=taille*taille
    i=taille-1
    while n!=0:
        if (n%2)!=0:
            res[i]=True
        n=n//2
        i=i-1
    return res

#Q24
"""Soit i un variant de boucle représentant les configurations non présentes dans espace. I est décroissant mais >0 #ligne 6 qui diminue les config de espace et ligne 9 qui peut stpper tt """

#Q25
"""cf programme recherche"""

test=[True,False,True,False,True,False,False,True,False,False,False]

print(avancer_debut_bloquer(test,False,1))

print(versEntier([True,True,False,True,False,False]))
