﻿#Quelques exercices sur les poolynômes

import numpy as np

def degre_Poly(P):
    n=len(P)
    degre=-100
    if n!=0:
        for i in range(n):
            if P[i]!=0:
                degre=i
    return degre

Nul=[0,0,0]
P_degtest=[1,0,0,0,0,3,0]
P2_degtest=[1,0,0,0]

degre=degre_Poly(P2_degtest)

def Dila_Poly(gamma,P):
    n=len(P)
    for i in range(n):
        P[i]=P[i]*gamma
    return P


def Somme_Poly(P,Q):
    n1=len(P)
    n2=len(Q)
    m=max(n1,n2)
    P1=P+[0]*(m-n1)
    Q1=Q+[0]*(m-n2)
    S=[]
    for i in range(m):
        S.append(P1[i]+Q1[i])
    return S

P_test=[1,1,1]          #La case i d'un polynôme représente le coefficient associé à X**i
Q_test=[2,3,4,5,6]

#S=Somme_Poly(P_test,Dila_Poly(-1,Q_test))

def Produit_Poly(P,Q):
    n1=degre_Poly(P)
    n2=degre_Poly(Q)
    s=n1+n2
    P=P+[0 for i in range(s-n1)]
    Q=Q+[0 for i in range(s-n2)]
    Prod=[0 for i in range(s+1)]
    for k in range(s+1):
        ck=0
        for l in range(k+1):
            ck+=P[l]*Q[k-l]
        Prod[k]=ck
    return Prod

P_test2=[1,1]       # P(X)= 1 + X
Q_test2=[2,2,3]     # Q(X)= 2 + 2X + 3X**2          PQ(X)= 2 + 4X + 5X**2 + 3X**3

#print(Produit_Poly(P_test2,Q_test2))

def Deriv_Poly(P):
    n=degre_Poly(P)
    Deriv=[0 for i in range(n)]
    for k in range(n):
        Deriv[k]=(k+1)*P[k+1]
    return Deriv

P_test3=[1,2,3,4,5,6]     # P(X)= 1 + 2X + 3X**2 + 4X**3 + 5X**4 + 6X**5        P'(X)= 2 + 6X + 12 X**2 + 20X**3 + 30X**4

#print(Deriv_Poly(P_test3))

def Deriv_kieme_Poly(P,k):
    n=degre_Poly(P)
    Deriv_kieme=[P[i] for i in range(n+1)]
    for i in range(k):
        Deriv_kieme=Deriv_Poly(Deriv_kieme)
    if Deriv_kieme==[]:
        Deriv_kieme=[0]
    return Deriv_kieme

print(Deriv_kieme_Poly(P_test3,1))



