﻿from turtle import *
from math import *
import matplotlib.pyplot as plt

#Problème 1:

#Question 1:

def maison():
    Turtle()
    reset()
    forward(100)
    left(90)
    forward(100)
    left(30)
    forward(100)
    left(120)
    forward(100)
    left(30)
    forward(100)

#print(maison())

def benzene():
    a=sqrt(3)/2*100
    Turtle()
    reset()
    left(60)
    forward(a)
    left(30)
    forward(150)
    left(30)
    forward(a)
    left(120)
    forward(a)
    left(30)
    forward(150)
    left(30)
    forward(a)

print(benzene())

#Question 2:

""" F(100,30,F+++F+F++++F+F) """

#Question 3:

def dessiner(unite,angle,motif):
    Turtle()
    reset() #azimut remis à zéro
    for m in motif:
        if m=='F':
            forward(unite)
        elif m=='+':
            left(angle)
        elif m=='-':
            right(angle)

motif='F+++F+F++++F+F'
#dessiner(100,30,motif)

#Question 4:

def suivant(motif,regle):
    motif_suivant=''
    for m in motif:
        if m=='F':
            motif_suivant+=regle
        else:
            motif_suivant+=m
    return motif_suivant

#Question 5:

def evolution(axiome,regle,etape):
    motif=axiome
    for i in range(etape): #va bien tourner n etape
        motif=suivant(motif,regle)
    return motif

#Question 6:

"""Un F de l'axiome est remplacé par 4 F et ce pour les 3F de l'axiome n fois successivement d'où 3x4**n F à la nétape.
Un F est remplacé par 4 '+' ou '-' et ce 3 fois sachant qu'initialement on a 4 symbole : en n on aura donc 4**n+3x4**n = 4**n * ( 3 + 1) = 4**(n+1)
On le montre par récurrence immédiate"""

#Question 7:

"""A l'étape 4, on aa fait 256*3*2 = 1280 pas  et 60*4**5 = 61440 degre de rotation, donc il faudra environ 78.08"""

#Question 8:

""" Ca sera simplement un code """

def maison_pyplot():
    X=[0,100,100,50,0,0]
    Y=[0,0,100,100+100*sqrt(3)/2,100,0] #Le point D a une ordonnée de 100 + 100*sin(pi/3) cad 60°
    plt.figure('maison')
    plt.axis('equal')
    plt.plot(X,Y,'k-')
    plt.show()

#Question 9:

""" si on tombe surr un déplacement l :
    - d = d
    - x = x + l*cos(a) #abscisse
    - y = y + l*sin(a) #ordonnee

    si on tombe sur '+':
    - d = d + a ; d = d - a (si '-')
    - x = x
    - y = y    """

#Question 10:

def dessine(unite,angle,motif): #on va utiliser la question 9
    X=[0]       #coord (0,0) et d vaut 0
    Y=[0]
    D=[0]
    for m in motif:
        x=X[-1] #on se met au derniere coord pour calculer la nouveelle position
        y=Y[-1]
        d=D[-1]
        if m=='F':
            X.append(x+unite*cos(d*pi/180))        #les fonctions cos et sin sont en radiaan sur python 180 <--> pi
            Y.append(y+unite*sin(d*pi/180))        #Question 9
            D.append(d)
        elif m=='+':
            X.append(x)
            Y.append(y)
            D.append(d+angle)
        elif m=='-':
            X.append(x)
            Y.append(y)
            D.append(d-angle)
    plt.figure('dessine')
    plt.axis('equal')
    plt.plot(X,Y,'k-')
    plt.show()

#Question 11:



#Question 12:

"""Règle : 'F+F++++++++++++++++++' """

#Question 13:

"""Ces nouveaux symboles vont permettre dee créer certains motifs plus rapideent #Les motifs où on a une chaîne principale avec des chaînes secondaires. """

#Question 14:

"""Il s'agit d'un H couché"""

#Question 15:

def dessine_ramif(unite,angle,motif,azimut): #On a réler les coord initialles et l'azimut nul
    X=[0]
    Y=[0]
    D=[0]
    pile=[]
    plt.figure('dessin_ramif')
    plt.axis('equal')
    for m in motif:
        x=X[-1]
        y=Y[-1]
        d=D[-1]
        if m=='F':
            x1=x+unite*cos(d*pi/180)
            y1=y+unite*sin(d*pi/180)
            X.append(x1)
            Y.append(y1)
            D.append(d)
            plt.plot([x,x1],[y,y1],'k-')
        elif m=='+':
            X.append(x)
            Y.append(y)
            D.append(d+angle)
        elif m=='-':
            X.append(x)
            Y.append(y)
            D.append(d-angle)
        elif m=='[': #On reste comme on est
            pile.append((x,y,d)) #Liste de tuples
        elif m==']':
            x,y,x=pile.pop() #On retourne aux dernières coord de la pile
    plt.show

#dessine_ramif(10,20,'F[+F]F[-F]F',0)

#Question 16:

motif_Koch=evolution('F','F[+F]F[-F]F',4)
#dessine_ramif(10,20,motif,0)

#Question 17:

def verifie(chaine):
    n=len(chaine)
    cpt=0
    i=0
    while cpt>=0 and i<n:
        if chaine[i]=='[':
            cpt+=1
        elif chaine[i]==']':
            cpt-=1
        else:
            None
        i+=1
    if i==n and cpt>=0:
        return True
    else:
        return False

print(verifie(']+F-F][---)'))