﻿#Correction DS 2 Informatique ( X-ENS MP 2015 - Cours )

from math import *
from random import *

#Exercices :

# Exercice 1:

def est_triee(T):
    cpt=0
    n=len(T)
    for i in range(n-1):
        if T[i]<=T[i+1]:
            cpt+=1
    return cpt==n-1

test_1=[1,2,3,4,5]
test_2=[1,3,2,2,4]

#print(est_triee(test_1))
#print(est_triee(test_2))

# Exercice 2:

def estDansAPartirDe(T,x,i):
    drap=False
    n=len(T)
    for k in range(i,n):
        if T[k]==x:
            drap=True
    return drap

#print(estDansAPartirDe(test_1,6,3))
#print(estDansAPartirDe(test_1,2,1))
#print(estDansAPartirDe(test_1,1,3))

def sansDoublons(T):
    LL=[]
    n=len(T)
    for k in range(n):
        if not estDansAPartirDe(T,T[k],k+1):
            LL.append(T[k])
    return LL

def sansDoublons2(T):
    L=[T[0]]
    n=len(T)
    for k in range(1,n):
        if estDansAPartirDe(L,T[k],0)==False:
            L.append(T[k])
    return L

test_3=[1,2,2,4,5,5,7,9,9,10,11,7]

#print(sansDoublons(test_3))
#print(sansDoublons2(test_3))

def sansDoublons_EP(T):
    n=len(T)
    i=n-1
    while i>0 :
        if estDansAPartirDe(T[:i],T[i],0)==True:
            T.pop(i)
        i-=1
    return T

#print(sansDoublons_EP(test_3))

def fusion(T1,T2):
    if T1==[] or T2==[]:
        return T1+T2
    elif T1[0]<T2[0]:
        return [T1[0]]+fusion(T1[1:],T2)
    else:
        return [T2[0]]+fusion(T1,T2[1:])

def Tri_Fusion(T):                                  #Compleexité en O(nln(n)) ou en O(n**2)
    n=len(T)
    if n<=1:
        return T
    else:
        T1=T[:n//2]
        T2=T[n//2:n]
        return fusion(Tri_Fusion(T1),Tri_Fusion(T2))

def sansDoublonDansTableauTrie(T):
    n=len(T)
    L=[]
    for k in range(n-1):
        if T[k]<T[k+1]:
            L.append(T[k])
    if L==[] or T[-1]!=L[-1]:
        L.append(T[-1])
    return L

test_4=[2,2,2,2,2,2,2]
test_5=[1,2,2,4,5,6,6,7,7]

#print(sansDoublonDansTableauTrie(test_4))
#print(sansDoublonDansTableauTrie(test_5))

def suppDoublonDansTableau(T):
    return sansDoublonDansTableauTrie(Tri_Fusion(T)),T

test_6=[randint(1,6) for k in range(20)]
#print(suppDoublonDansTableau(test_6))


#Problème X :

#Question 1:

Reseau_A=[5,[[0,1],[1,2],[2,3],[3,0],[0,2]]]
Reseau_B=[5,[[0,1],[1,2],[2,4],[4,3],[3,1],[2,3]]]

#Question 2:

def creerReseauVide(n):
    return [n,[]]

#print(creerReseauVide(50))

#Question 3:

def estUnLienEntre(paire,i,j):
    return paire==[i,j] or paire==[j,i]

#Question 4:

def sontAmis(reseau,i,j):
    for paire in reseau[1]:
        if estUnLienEntre(paire,i,j):
            return True
    return False

""" Dans le pire cas il y a m amitié et supposons i,j est la dernière amitié donc complexité en O(m)"""

#Question 5:

def declareAmis(reseau,i,j):
    if not sontAmis(reseau,i,j):
        reseau[1].append([i,j])

#Question 6:

def listeDesAmisDe(reseau,i):
    amis=[]
    for paire in reseau[1]:
        if paire[0]==i:
            amis.append(paire[1])
        elif paire[1]==i:
            amis.append(paire[0])
    return amis

def listeDesAmisDeV2(reseau,i):
    amis=[]
    n=reseau[0]
    for k in range(n):
        if sontAmis(reseau,i,k):
            amis.append(k)
    return amis

#print(listeDesAmisDe(Reseau_A,4))
#print(listeDesAmisDeV2(Reseau_A,4))
#print(listeDesAmisDe(Reseau_B,3))
#print(listeDesAmisDeV2(Reseau_B,3))

""" Complexité en O(m) au pire #nbr de liens de d'amitié """

#Question 7:

""" Représentation filiale A """

parent_A=[5,1,1,3,4,5,1,5,5,7]

""" Représentation filiale B """

parent_B=[3,9,0,3,9,4,4,7,1,9]

#Question 8:

def creerPartitionEnSingletons(n):
    return [k for k in range(n)]

#Question 9:

def representant(parent,i):
    while i!=parent[i]:
        i=parent[i]
    return i

#print(representant(parent_A,9))
#print(representant(parent_B,6))
#print(representant(parent_A,3))

""" Pire complexité en O(n) correspond à parent=[0,1,2,...,n-1]"""

#Question 10:

def fusion(parent,i,j):
    p=representant(parent,i)
    q=representant(parent,j)
    parent[p]=q


#Question 11:

""" fusion(parent,0,1)
    fusion(parent,0,2)
    ...
    fussion(parent,0,n-1)   correspond à une complexité en O(n**2) """

#Question 12:

parent_fig2=[6,9,3,3,3,5,5,5,1,9,10,1,4,9,11,9]

def representantV2(parent,i):
    if i!=parent[i]:
        tampon=representantV2(parent,parent[i])
        parent[i]=tampon
    return parent[i]

def representantV3(parent,i):
    list_ancetre=[i]
    while i!=parent[i]:
        i=parent[i]
        list_ancetre.append(i)
    for k in list_ancetre:
        parent[k]=parent[i]
    return parent[i]

#print(representantV2(parent_A,9))
#print(representantV2(parent_fig2,14))
#print(representantV3(parent_fig2,14))

#Question 13:

def listeDesGroupes(parent):
    liste_groupe=[]
    represent=[]
    n=len(parent)
    for i in range(n):
        r=representantV2(parent,i)  #on réinitialise ces valeurs à chaque entrée dans la boucle
        k=0
        while k<len(represent) and represent[k]!=r:
            k+=1
        if k==len(represent):
            represent.append(r)
            liste_groupe.append([])
        liste_groupe[k].append(i)
    return liste_groupe

#print(listeDesGroupes(parent_fig2))

#Question 14:

def coupeMinimumRandomisee(reseau):
    n=reseau[0]
    parent=creerPartitionEnSingletons(n)                                            #étape 1
    nb_groupes=n
    nbLiens=len(reseau[1])                                                          #étape 2
    while nb_groupes > 2 and nbLiens > 0:                                            #étape 3
        nbLiens-=1
        k=randint(0,nbLiens)                                                        #étape 3.a
        [i,j]=reseau[1][k]   #le kieme lien est bien [i,j]
        ri=representantV2(parent,i)
        rj=representantV2(parent,j)
        if ri!=rj:                                                                  #étape 3.b
            fusion(parent,ri,rj)
            nb_groupes-=1  #On a fusionné 2 groupes il reste donc n-1 groupes
        reseau[1][k],reseau[1][nbLiens]=reseau[1][nbLiens],reseau[1][k]             #étape 3.c
        if nb_groupes > 2:                                                          #étape 4
            r0=representantV2(parent,0)
            i=1
            while nb_groupes > 2:
                ri=representantV2(parent,i)
                if r0!=ri:
                    fusion(parent,r0,ri)
                    nb_groupes-=1
                i+=1
        return parent                                                               #étape 5

test_sujet=[8,[[0,2],[2,3],[3,1],[1,0],[0,3],[1,2],[2,4],[3,5],[4,6],[6,7],[7,5],[5,4],[4,7],[6,5]]]
print(coupeMinimumRandomisee(test_sujet))

#Question 15:

def tailleCoupe(reseau,parent):
    nbLiens=0
    for [i,j] in reseau[1]:
        if representantV2(parent,i)!=representantV2(parent,j):
            nbLiens+=1
    return nbLiens

#Question BDD 16/17/18:

""" SELECT id2 FROM liens WHERE id1=x

    SELECT nom,prenom FROM INDIVIDUS JOIN LIENS ON id=id2  WHERE id1=x

    SELECT b.id2 FROM LIENS a JOIN LIENS b ON a.id2=b.id1  WHERE a.id1=x"""

