﻿from math import *
import numpy as np

#Partie 1:

#Exercice 1:

def Degre1(a,b):
    if a==0 and b!=0:
        return []
    elif a==0 and b==0:
        return"IR"
    elif a!=0:
        return [-b/a]

def Degre2(a,b,c):
    if a==0:
        return Degre1(b,c)
    else:
        d=b**2-4*a*c
        if d==0:
            return [-b/(2*a)]
        else:
            d2=abs(d)**0.5
            if d<=0:
                return [(-b-d2*1j)/(2*a),(-b+d2*1j)/(2*a)]
            else:
                return [(-b-d2)/(2*a),(-b+d2)/(2*a)]

#Exercice 2:

def produit(n,p):
    prod=1
    for k in range(1,p+1):
        prod*=(n+1-k)/k
    return prod

def produitr(n,p):
    if p==1:
        return n
    else:
        return (n+1-p)/p*produitr(n,p-1)

#Exercice 3:

def f(x):
    return sin(x)

def rectangle(a,b,n,f):
    cste=(b-a)/n
    som=0
    for k in range(1,n+1):
        som+=f(a+k*cste)
    return cste*som

#print(rectangle(0,pi,100,f))

#Exercice 4:

def rec1(u0,n,f):
    u=u0
    for k in range(n):
        u=f(u)
    return u

def rec1r(u0,n,f):
    if n==0:
        return u0
    else:
        return f(rec1r(u0,n-1,f))

def rec2(u0,eps,f):
    u=u0
    n=0
    while abs(f(u)-u)>=eps:
        u=f(u)
        n+=1
    return u,n   #Tuple

#Exercice 5:

def initialise(n):
    return np.zeros((n,n))

def TrianglePascal(n):
    T=initialise(n)
    for i in range(n):
        T[i][0]=1
    for i in range(1,n):
        for j in range(1,n):
            T[i][j]=T[i-1][j-1]+T[i-1][j]
    return T

"""Complexité en o(n**2) --> boucle imbriquée dans une boucle"""

def binomr(n,p):
    if p==0:
        return 1
    elif p>n:
        return 0
    else:
        return binomr(n-1,p-1)+binomr(n-1,p)

"""complexité en o(n) plus rapide que la méthode itérative"""

#print(TrianglePascal(8))

#Exercice 6:

def Hamming(c1,c2):
    d=0
    l=len(c1)
    for k in range(l):
        if c1[k]==c2[k]:
            d+=1
    return d

def Hamming2(c1,c2):
    l1=len(c1)
    l2=len(c2)
    if l1>=l2:
        L1=c2
        L2=c1
    else:
        L1=c1
        L2=c2
    l11=len(L1)
    l21=len(L2)
    d=Hamming(L1,L2[0:l11]) #distance minimale par défaut
    ind=0
    for k in range(1,l21+1-l11):
        dprov=Hamming(L1,L2[k:k+l11])
        if dprov<d:
            d=dprov
            ind=k
    return d,ind

#Exercice 7:

"""ck= somme(l=0:k) a(m)*b(l-m)"""

def prod_poly(P,Q):
    m=len(P)-1
    n=len(Q)-1
    r=m+n
    Pextend=P+n*[0]
    Qextend=Q+m*[0]
    R=np.zeros(r+1)
    for k in range(r+1):
        for l in range(k+1):
            R[k]+=Pextend[l]*Qextend[k-l]
    return R

#print(prod_poly([1,2,3],[1,4,9]))

"""" Complexité en o((m+n)**2)"""

#Exercice 8:

def test(mot):
    n=len(mot)
    drapeau=True
    for i in range(n//2):
        if mot[i]!=mot[n-1-i]:
            drapeau=False
    return drapeau

def trouve(phrase):
    drapeau=False
    separe=phrase.split(' ')
    for mot in separe:
        if test(mot)==True:
            drapeau=True
            return mot
    return ''

def trouve2(phrase):
    n=len(phrase)
    i=0
    while i<=n:
        mot=''
        while phrase[i]!='':
            mot+=phrase[i]
            i+=1
        if test(mot)==True:
            return mot
        i+=1
    return ''

#Problème :

#Question 1:

arbre12=[10,[5,[1,[],[]],[2,[],[]]],[6,[3,[],[]],[4,[],[]]]]

#Question 2 à 4:
# r pour racine
# fg et fd pour fils gaauche et fils droit

def construit_arbre_vide():
    return []

def construit_arbre(r,fg,fd):
    return [r,fg,fd]

def construit_feuille(r):
    return[r,construit_arbre_vide(),construit_arbre_vide()]

#Question 5:

test=construit_arbre(4,construit_feuille(5),construit_arbre(6,construit_feuille(1),construit_feuille(2)))
#print(test)

#Question 6:

def arbre_vide(arbre):
    return arbre==[]

#Question 7:

def racine(arbre):
    return arbre[0]

def fils_gauche(arbre):
    return arbre[1]

def fils_droit(arbre):
    return arbre[2]

#Question 8:

def compte(arbre):
    if abre_vide(abre):
        return 0
    else:
        return 1+compte(fils_gauche(arbre))+compte(fils_droit(arbre))


#Question 9:

def somme(arbre):
    if abre_vide(arbre):
        return 0
    else:
        return racine(arbre)+somme(fils_gauche(arbre))+somme(fils_droit(arbre))

#Question 10:

def hauteur(arbre):
    if abre_vide(arbre):
        return 0
    else:
        return 1+max(hauteur(fils_gauche(arbre)),hauteur(fils_droit(arbre)))

#Question 11:

def parcours(arbre):
    if arbre_vide(arbre):
        return []
    else:
        return [racine(arbre)]+parcours(fils_gauche(arbre))+parcours(fils_droit(arbre))

#Question 12 et 13:

def inserer(e,arbre):
    if arbre_vide(arbre):
        return construit_feuille(e)
    else:
        rac=racine(arbre)
        if e<rac:
            return construit_arbre(rac,inserer(e,fils_gauche(arbre)),fils_droit(arbre))
        else:
            return construit_arbre(rac,fils_gauche(arbre),inserer(e,fils_droit(arbre)))

def convertir_liste_en_arbre(L):
    if L==[]:
        return construit_arbre_vide()
    else:
        prem_elem=L[0]
        n=len(L)
        newL = L[1:n]
        return inserer(prem_elem,convertir_liste_en_arbre(newL))

def tri(L):
    return parcours(convertir_liste_en_arbre(L))

L=[5,3,7,2,10,76,100,32]
#print(tri(L))
#print(inserer(43,arbre12))

def recherche_elem(e,arbre):
    if arbre_vide(arbre):
        return False
    elif e==arbre[0]:
        return True
    elif e<arbre[0]:
        return recherche_elem(e,arbre[1])
    else:
        return recherche_elem(e,arbre[2])


abr = convertir_liste_en_arbre(L)

def display_arbre_largeur(arbre):
    if not arbre_vide(arbre):
        if not arbre_vide(arbre[1]) and not arbre_vide(arbre[2]):
            return arbre[0],display_arbre_largeur(arbre[1]),display_arbre_largeur(arbre[2])
        elif arbre_vide(arbre[1]) and not arbre_vide(arbre[2]):
            return arbre[0],display_arbre_largeur(arbre[2])
        elif not arbre_vide(arbre[1]) and arbre_vide(arbre[2]):
            arbre[0],display_arbre_largeur(arbre[1]),"patate"
        else:
            return arbre[0]
    else:
        return 0

print(display_arbre_largeur(abr))
print(abr)
print(recherche_elem(3,abr))
print(tri(L))




