﻿#TP tris

from random import *
import numpy as np
import time
import copy
from math import *

#Fonctions pour les piles:

def creer_pile():
    return []

def empiler(p,v):
    return p.append(v)

def depiler(p):
    assert len(p)>0,'pile vide'
    return p.pop()

def taille(p):
    return len(p)

def est_vide(p):
    return p==[]

def sommet(p):
    if estvide(p):
        return "Rien"
    else:
        return p[-1]

#Fonctions de tris et d'insertion:

def InsererR(e,L):
    if L==[]:
        return [e]
    elif e<L[0]:
        return [e]+L
    else:
        return [L[0]] + InsererR(e,L[1:])

def Tri_InsertionR(L):
    n=len(L)
    if n<=1:
        return L
    else:
        InsererR(L[0],Tri_InsertionR(L[1:]))

def Tri_InsertionR_EP(L):
    n=len(L)
    for i in range(1,n):
        x=L[i]
        j=i
        while j>0 and x<L[j-1]:
            L[j]=L[j-1]
            j-=1
        L[j]=x
    return L

def Insere1(x,L):
    i=len(L)
    L.append(x)
    while i>0 and x<L[i-1]:
        L[i]=L[i-1]
        i-=1
    L[i]=x

def Tri_Insertion2(L):
    n=len(L)
    for k in range(n):
        return Insere1(L[k],L[:k])
    return L

def quicksort(L):
    if len(L)<=1:
        return L
    else:
        x=L[0]
        L.remove(x)
        L_inf=[]
        L_sup=[]
        for e in L:
            if e<=x:
                L_inf.append(e)
            else:
                L_sup.append(e)
        return quicksort(L_inf)+[x]+quicksort(L_sup)

T_test2=[0,1,0,2,1]
#print(quicksort(T_test2))

def fusion(L1,L2):
    if L1==[] or L2==[]:
        return L1+L2
    elif L1[0]<=L2[0]:
        return [L1[0]]+fusion(L1[1:],L2)
    else:
        return [L2[0]]+fusion(L1,L2[1:])

def Tri_Fusion(L):
    n=len(L)
    if n<=1:
        return L
    else:
        L1=L[:n//2]
        L2=L[n//2:n]
        return fusion(Tri_Fusion(L1),Tri_Fusion(L2))

test_333=[uniform(-50,50) for k in range(20)]
#print(Tri_Fusion(test_333))

#Exercice 0:

def Trouve1(L,o):
    return o in L

def Trouve2(L,o):
    ind=-1
    n=len(L)
    for i in range(n):
        if L[i]==o:
            ind=i
    return ind

def nbrOccurences(L,o):
    cpt=0
    n=len(L)
    for i in range(n):
        if L[i]==o:
            cpt+=1
    return cpt

def ListeOccurences(L,o):
    n=len(L)
    LO=[]
    for i in range(n):
        if L[i]==o:
            LO.append(i)

def PremiereOccurence1(L,o):
    if Trouve1(L,o):
        LO=ListeOccurences(L,o)
    return LO[0]

def PremiereOccurence2(L,o):
    if Trouve1(L,o):
        n=len(L)
        ind=0
        while L[i]!=o:
            ind+=1
        return ind

#Exercice 1:

def est_triee(L):
    cpt=0
    n=len(L)
    for i in range(1,n):
        if L[i-1]<=L[i]:
            cpt+=1
    return cpt==n-1

L_test1=[1,2,3,4,5]
#print(est_triee(L_test1))

#Exercice 2:

def permuteDroite(T,i,j):
    for k in range(i+1):
        tampon=T[j-(k+1)]
        T[j-(k+1)]=T[j-k]
        T[j-k]=tampon

#print(permuteDroite(L_test1,1,3))

def permuteGauche(T,i,j):
    n=j-i
    for k in range(n):
        tampon=T[i+k]
        T[i+k]=T[i+k+1]
        T[i+k+1]=tampon

L_test2=[1,5,2,3,4,6]
#print(permuteGauche(L_test2,1,4))

def transpose1(T,i,j):
    tampon=T[i]
    T[i]=T[j]
    T[j]=tampon

def transpose2(T,i,j):
    T[i],T[j]=T[j],T[i]

def permute_Droite(T,i,j):
    for k in range(j-i):
        transpose1(T,j-(k+1),j-k)

L_test3=[1,3,4,5,2,6]
#print(permute_Droite(L_test3,1,4))

def permute_Gauche(T,i,j):
    for k in range(j-i):
        transpose1(T,i+k,i+(k+1))

L_test4=[1,4,2,3,5,6,7]
#print(permute_Gauche(L_test4,1,3))

def insere(T,x):
    j=len(T)
    T.append(x)
    while j>0 and T[j-1]>x:
        T[j]=T[j-1]
        j-=1
    T[j]=x

L_test5=[1,2,4,5,6]
#print(insere(L_test5,3))

#Exercice 3:

def inverse1_0(T):
    L=T[::-1]
    return L

def inverse1_1(T):  #en o(n) # boucle for
    n=len(T)
    L=[0 for i in range(n)]
    for k in range(n):
        L[k]=T[-(k+1)]
    return L

L_test6=[1,2,3,4]
#print(inverse1_0(L_test6))
#print(inverse1_1(L_test6))

def inverse_enplace(T):  #en log(n) ??
    n=len(T)
    for k in range(n):
        permute_Droite(T,k,n-1)
    return T

#print(inverse_enplace(L_test6))

#Exercice 4:

def Melange_Knuth(L):
    n=len(L)
    for i in range(n):
        j=random.randint(i,n-1)
        transpose1(L,i,j)

#Exercice 5:

def distance_min(L):
    n=len(L)
    if n>1:
        ind1=0
        ind2=1
        d_min=abs(L[ind2]-L[ind1])
        for i in range(n):
            for k in range(i+1,n):
                d=abs(L[i]-L[k])
                if d<d_min:
                    ind1=i
                    ind2=k
                    d_min=d
    else:
        d_min=0
    return d_min

T_test1=[0,2,3,0,4,5]
#print(distance_min(T_test1))

def distance_min_optimale(L):
    n=len(L)
    if n>1:
        L=quicksort(L)
        d_min=L[1]-L[0]
        for k in range(1,n-1):
            d=L[k+1]-L[k]
            if d<d_min:
                d_min=d
    return d_min,L

T_test3=[0,2,15,55,454,54,54,5845,454,548,754,878,5458,7545]
#print(distance_min_optimale(T_test3))

#Exercice 6:

def estDansAPartirDe(L,deb,x):
    n=len(L)
    drap=False
    for k in range(deb,n):
        if L[k]==x:
            drap=True
    return drap

def dedoublonnage(L):
    LL=[]
    n=len(L)
    for k in range(n):
        if not estDansAPartirDe(L,k+1,L[k]):
            LL.append(L[k])
    return LL

test_33=[1,2,2,4,5,5,7,9,9,10,11,7]
T_test4=[0,2,4,5,2]
#print(dedoublonnage(T_test4))
print(dedoublonnage(test_33))

def place_insertion(L,i):  #2 fonctions pour dedoublonnage2
    ind=i
    while ind>0 and L[i]<L[ind-1]:
        ind-=1
    return ind

def Tri_Insertion_Permutation(L):
    n=len(L)
    for k in range(1,n):
        permute_Droite(L,place_insertion(L,k),k)

T_test5=[0,15,15,15,20,0,25510,51515,120,51,51,515,15,15,1,51,51]
#print(Tri_Insertion_Permutation(T_test5))

def dedoublonnage2(L):
    n=len(L)
    if n<1:
        return []
    else:
        L_triee=copy.deepcopy(L)
        Tri_Insertion_Permutation(L_triee)
        L_sansdoubl=L_triee[0]
        for i in range(1,n):
            if L_triee[i]!=L_triee[i-1]:
                L_sansdoubl.append(L_triee[i])
        return L_sansdoubl

#print(dedoublonnage2(T_test5))


#Exercice 7:

def plusPetitque(L,x):
    n=len(L)
    cpt=0
    for k in range(n):
        if L[k]<x:
            cpt+=1
    return cpt

#Exercice 8:


#Exercice 9:

def IndiceMax(L):
    ind=0
    n=len(L)
    for i in range(1,n):
        if L[i]>L[ind]:
            ind=i
    return ind

def TriParExtraction(L):
    n=len(L)
    for k in range(n-1):
        ind_max=IndiceMax(L[:n-k])
        transpose1(L,n-(k+1),ind_max)
    return L

T_test0=[2,3,874,5484,5878,754,8754587,5457,54,5875,4587,54,57,54]
#print(TriParExtraction(T_test0))

#Exercice 12:

def compare_time_tris(L):
    L1=copy.deepcopy(L)
    L2=copy.deepcopy(L)
    deb1=time.clock()
    L1=Tri_Insertion2(L1)
    fin1=time.clock()
    deb2=time.clock()
    L2=quicksort(L2)
    fin2=time.clock()
    temps1=fin1-deb1
    temps2=fin2-deb2
    t=temps2-temps1
    return (t,"Temps tri rapide moins temps tri par insertion") #,L,L1,L2)

test_alpha=[uniform(-50,50) for k in range(1000000)]  #5,6s de diff pour n=10**6

#print(compare_time_tris(test_alpha))

#Exercice 13:

def tri_par_dichotomie(L,x): #L est supposée triée placement par dicho
    n=len(L)
    L1=L[:n//2]
    L2=L[n//2:]
    if  n>1:
        if x>L1[0] and x<=L1[-1]:
            return place_insertion_dichotomie(L1,x)+L2
        elif x>L2[0] and x<=L2[-1]:
            return L1+place_insertion_dichotomie(L2,x)
        elif x>=L2[-1]:
            return L1+L2+[x]
        elif x<=L1[0]:
            return [x]+L1+L2
        elif x>L1[-1] and x<=L2[0]:
            return L1+[x]+L2
    else:
        if x<L2[0]:
            return [x]+L2
        else:
            return L2+[x]

T_test6=[1,2,3,4,5,6,7,8,9,10,11,12]
#print(place_insertion_dichotomie(T_test6,7))

def insere_spe_dicho(L,i,x):
    L=L[:i]+[x]+L[i:]
    return L

Y_test0=[1,2,3]
#print(insere_spe_dicho(Y_test0,1,1.8))

def place_insertion_dichotomie_optimal(L,i,j,x): #en 2 fonctions une qui cherche la place et l'autre qui trie,
    if x>L[j]:                                   #cette fonction recherhce l'insertion par dicho
        return j+1
    while i!=j:
        mil=(i+j)//2
        if x<=L[mil]:
            j=mil
        else:
            i=mil+1 # i+1 pcq on a test inégalité large
    return i  #correspond à l'indice d'insertion

def dicho_sort(L):
    n=len(L)
    for i in range(1,n): #on va placer chaque valeur de la liste dont une rangée par défaut
        if L[i]<L[i-1]:
            ind=place_insertion_dichotomie_optimal(L,0,i-1,L[i]) #à repérer l'indice d'insertion
            x=L.pop(i)                  #supprime l'élément en position i de la liste et l'affecte à x, x que
            L=insere_spe_dicho(L,ind,x) #l'on va ensuite placer vu qu'on a trouver son indice
    return L

Y_test1=[1,2154,1,5452,154,1254,51,54515555,54,852,154,512,542154,454]
#print(dicho_sort(Y_test1))

#Exercice 14:

def calcul_mediane_tableau_trie(T):   #Si T est un tableau trié
    n=len(T)
    if n%2!=0:
        return T[n//2]
    else:
        return (T[n//2-1]+T[n//2])/2

def calcul_mediane_tableau_non_trie(T):
    n=len(T)
    T=quicksort(T)
    return calcul_mediane_tableau_trie(T)

Y_test20=[1,2,3,4]
Y_test21=[1,2,3,4,5]
Y_test22=[1,5,8,2,0,9,11]       #Y_test22(trié)=[0,1,2,3,8,9,11]

#print(calcul_mediane_tableau_trie(Y_test20))
#print(calcul_mediane_tableau_non_trie(Y_test22))

def iemeElement(T,i,deb,fin):
    n=len(T)
    for k in range(n):
        cpt=0    #réinitialisation de cpt à chaque entrer dans la grande boucle
        for l in range(n):
            if T[k]>T[l]:
                cpt+=1
        if  (k>=deb and k<=fin) and cpt==i-1:
            return T[k] #stop la boucle; on a trouvé notre ième élément le plus petit

Y_test3=[-53,-32,0,7,12,28,40,82]
fin=len(Y_test3)

#print(iemeElement(Y_test3,1,0,fin))
#print(iemeElement(Y_test3,fin,0,fin))
#print(iemeElement(Y_test3,fin//2,0,fin))

def iemeElementV2(T,i,deb,fin):
    n=len(T)
    for k in range(n):
        cpt=0    #réinitialisation de cpt à chaque entrer dans la grande boucle
        for l in range(n):
            if T[k]>T[l]:
                cpt+=1
        if  (k>=deb and k<=fin) and cpt==i-1:
            return T[k] #stop la boucle; on a trouvé notre ième élément le plus petit

test_beta=[1,2,3,4,5,6]

#print(iemeElementV2(test_beta,3,0,6))

def quicksort_nR1(T):
    n=len(T)
    L=[]
    f           #en suspend problèmee de type

Y_test4=[randint(1,100) for k in range(20)]

#print(quicksort_nR2(Y_test4))
